TheLittleSpoon/Controllers/ArticlesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using TheLittleSpoon.Models;
using TheLittleSpoon.Data;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.AspNetCore.Hosting;
using Microsoft.EntityFrameworkCore;
using Microsoft.AspNetCore.Authorization;

namespace TheLittleSpoon.Controllers
{
    public class ArticlesController : Controller
    {
        private readonly LittleSpoonDBContext _context;
        private readonly IHostingEnvironment _env;

        private readonly string _articlesTransitionDataPath;

        public ArticlesController(LittleSpoonDBContext context, IHostingEnvironment env)
        {
            _context = context;
            _env = env;

            // Set path to file that holds the article transitions for training the ML
            // note - make sure that the "Copy to Output Directory" property of the file is set to "Copy Always"
            _articlesTransitionDataPath = System.IO.Path.Combine(_env.WebRootPath, "ml", "articles-transition-data.txt");
        }

        [Authorize]
        // GET: Articles
        public async Task<IActionResult> Index()
        {
            return View(await _context.Articles.ToListAsync());
        }

        public IActionResult ArticleError()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        // GET: Articles/Details/?
        public async Task<IActionResult> Details(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles.Include(a => a.Category).FirstOrDefaultAsync(m => m.ArticleId == id);

            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            return View(article);
        }

        // GET: Articles/Create
        [Authorize]
        public IActionResult Create()
        {
            ViewBag.Categories = new SelectList(_context.Categories, "CategoryId", "Name");
            return View();
        }

        // POST: Articles/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Create([Bind("Header,Summary,Content,HomeImageUrl,CategoryId,Location,IsShowMap")] Article articleModel)
        {
            if (ModelState.IsValid)
            {
                articleModel.DateCreated = DateTime.Now;
                _context.Add(articleModel);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            return View(articleModel);
        }

        // GET: Articles/Edit/?
        [Authorize]
        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles.FindAsync(id);
            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            ViewBag.Categories = new SelectList(_context.Categories, "CategoryId", "Name");

            return View(article);
        }

        // POST: Articles/Edit/?
        [HttpPost]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> Edit(int id, [Bind("ArticleId,Header,Summary,Content,HomeImageUrl,CategoryId,Location,IsShowMap")] Article article)
        {
            if (id != article.ArticleId)
            {
                return RedirectToAction("ArticleError");
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Articles.Attach(article);
                    _context.Entry(article).Property(x => x.Content).IsModified = true;
                    _context.Entry(article).Property(x => x.Header).IsModified = true;
                    _context.Entry(article).Property(x => x.Summary).IsModified = true;
                    _context.Entry(article).Property(x => x.HomeImageUrl).IsModified = true;
                    _context.Entry(article).Property(x => x.CategoryId).IsModified = true;
                    _context.Entry(article).Property(x => x.Location).IsModified = true;
                    _context.Entry(article).Property(x => x.IsShowMap).IsModified = true;

                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!ArticleExists(article.ArticleId))
                    {
                        return RedirectToAction("ArticleError");
                    }
                    else
                    {
                        throw;
                    }
                }
                return RedirectToAction(nameof(Index));
            }
            return View(article);
        }

        // GET: Articles/Delete/?
        [Authorize]
        public async Task<IActionResult> Delete(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var article = await _context.Articles
                .FirstOrDefaultAsync(m => m.ArticleId == id);
            if (article == null)
            {
                return RedirectToAction("ArticleError");
            }

            return View(article);
        }

        // POST: Articles/Delete/?
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        [Authorize]
        public async Task<IActionResult> DeleteConfirmed(int id)
        {
            var article = await _context.Articles.FindAsync(id);
            _context.Articles.Remove(article);
            await _context.SaveChangesAsync();

            return RedirectToAction(nameof(Index));
        }

        private bool ArticleExists(int id)
        {
            return _context.Articles.Any(e => e.ArticleId == id);
        }

        public async Task<IActionResult> Search(int? category, string header, string summary, DateTime? date)
        {
            var result = _context.Articles.AsQueryable();

            if (category != null)
                result = result.Where(x => x.CategoryId == category);
            if (!String.IsNullOrWhiteSpace(header))
                result = result.Where(x => x.Header.Contains(header));
            if (!String.IsNullOrWhiteSpace(summary))
                result = result.Where(x => x.Summary.Contains(summary));
            if (date.HasValue)
                result = result.Where(x => x.DateCreated.Value.Date == date.Value.Date);

            return Json(result);
        }

        public async Task<IActionResult> Comments(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            var comments = await _context.Comments.Where(c => c.ArticleId == id.Value).ToListAsync();

            if (comments == null)
            {
                return RedirectToAction("ArticleError");
            }

            return Json(comments);
        }

        // This function is calles onlt when you "transition" between articles.
        // When a user presses an article in the "related" section, we first save the transition
        // and only then really redirect him to his requested article page
        public async Task<IActionResult> MoveRelated(int? prevId, int? newId)
        {
            if (prevId == null || newId == null)
            {
                return RedirectToAction("ArticleError");
            }

            // Insert to training-set only if the article id's are differnet
            if (prevId.Value != newId.Value)
            {
                // Create a new line for the training data file in format "0.0,0.0" (we need a float num for the ML model)
                string line = ((float)prevId).ToString("0.0") + ',' + ((float)newId).ToString("0.0");

                // Add new line to training data file
                System.IO.File.AppendAllText(_articlesTransitionDataPath, line + Environment.NewLine);
            }

            // Now really redirect to the requested article
            return RedirectToAction(nameof(Details), new { id = newId });
        }

        // This function is called via javascript in the "Details" view of an article
        public async Task<IActionResult> GetRelatedArticles(int? id)
        {
            if (id == null)
            {
                return RedirectToAction("ArticleError");
            }

            const int NUM_OF_RELATED_ARTICLES = 3;
            List<Article> relatedArticles = new List<Article>();

            try
            {
                // Get the related article to the viewed article
                int mlRelatedArticle = MachineLearning.GetRelatedArticle(_articlesTransitionDataPath, id.Value);

                // Make sure we don't recommend the same article as the viewed article
                if (mlRelatedArticle != id.Value)
                {
                    var article = await _context.Articles.FirstAsync(c => c.ArticleId == mlRelatedArticle);

                    if (article != null)
                    {
                        relatedArticles.Add(article);

                        // Get the related article to the related article
                        int mlRelatedToRelatedArticle = MachineLearning.GetRelatedArticle(_articlesTransitionDataPath, mlRelatedArticle);

                        // Check that the recommended article isn't itself or the previous recommended article
                        if (mlRelatedToRelatedArticle != mlRelatedArticle && mlRelatedToRelatedArticle != id.Value)
                        {
                            article = await _context.Articles.FirstAsync(c => c.ArticleId == mlRelatedToRelatedArticle);

TheLittleSpoon/Views/Articles/ArticleError.cshtml
@{
    ViewData["Title"] = "ArticleError";
}
<div class="text-center">
    <h1>The Little Spoon</h1>
    <h2>Oops! Looks like an error accured :(</h2>
    <h3>or... your'e the examiner and tried to fail us. nice try!</h3>
    <br />
    <br />
    <img src="~/images/AboutUs.svg" alt="ASP.NET" class="img-responsive" />
</div>

TheLittleSpoon/Views/Articles/Create.cshtml
@model TheLittleSpoon.Models.Article

@{
    ViewData["Title"] = "Create";
}

<h2>Create</h2>

<h4>Article</h4>

<hr />
<div class="row">
    <form asp-action="Create">
        <div class="col-md-4">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="ArticleId" />
            <div class="form-group">
                <label asp-for="Header" class="control-label"></label>
                <input asp-for="Header" class="form-control" />
                <span asp-validation-for="Header" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Summary" class="control-label"></label>
                <input asp-for="Summary" class="form-control" />
                <span asp-validation-for="Summary" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="CategoryId" class="control-label"></label>
                @Html.DropDownList("CategoryId", (SelectList)ViewBag.Categories, "Select Category", new { @class = "form-control" })
                <span asp-validation-for="CategoryId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="HomeImageUrl" class="control-label" title="Home-Image URL"></label>
                <input asp-for="HomeImageUrl" class="form-control" />
                <span asp-validation-for="HomeImageUrl" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Location" class="control-label"></label>
                <table>
                    <tr>
                        <th style="vertical-align:top;">
                            <div id="locationContainer" style="width:465px;">
                                <input asp-for="Location" class="form-control" id="locationSearch" autocomplete="off" />
                                <span asp-validation-for="Location" class="text-danger"></span>
                            </div>
                        </th>
                    </tr>
                    <tr>
                        <th>
                            <div id="myMap" style="height:300px;"></div>
                        </th>
                    </tr>
                    <tr>
                        <th>
                            <input type="checkbox" asp-for="IsShowMap" /> Show map in article?
                        </th>
                    </tr>
                </table>
            </div>
        </div>
        <div class="col-md-12">
            <div class=" form-group">
                <label asp-for="Content" class="control-label"></label>
                <textarea asp-for="Content" id="MDEditorTextArea"></textarea>
                <span asp-validation-for="Content" class="text-danger"></span>
            </div>
        </div>
        <div class="col-md-4">
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </form>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>


@section Scripts
{
<script type="text/javascript">
    $(document).ready(function () {
        make_markdown_editor($("#MDEditorTextArea")[0], "")
    })

    var map = null;

    function LoadMap() {
        map = new Microsoft.Maps.Map('#myMap', {
            credentials: "AglcOvofpKm1X-WOXDY3_Cr0bxdAbKzUid-4bp7Em3BxbNPK_kT-X8iWI4B1RF0H",
            showMapTypeSelector: false,
            showZoomButtons: false,
            showLocateMeButton: false
        });

        Microsoft.Maps.loadModule('Microsoft.Maps.Search', function () {
            var searchManager = new Microsoft.Maps.Search.SearchManager(map);
            var requestOptions = {
                bounds: map.getBounds(),
                where: decodeHtml(""),
                callback: function (answer, userData) {
                    map.setView({ bounds: answer.results[0].bestView });
                    map.entities.push(new Microsoft.Maps.Pushpin(answer.results[0].location))
                }
            };
            searchManager.geocode(requestOptions);
        });

        Microsoft.Maps.loadModule('Microsoft.Maps.AutoSuggest', function () {
            var options = {
                maxResults: 4,
                map: map
            };
            var manager = new Microsoft.Maps.AutosuggestManager(options);
            manager.attachAutosuggest('#locationSearch', '#locationContainer', selectedSuggestion);
        });
    }

    function selectedSuggestion(suggestionResult) {
        map.entities.clear();
        map.setView({ bounds: suggestionResult.bestView });
        var pushpin = new Microsoft.Maps.Pushpin(suggestionResult.location);
        map.entities.push(pushpin);
    }
</script>
<script type="text/javascript" src="https://www.bing.com/api/maps/mapcontrol?callback=LoadMap" async defer></script>
}

TheLittleSpoon/Views/Articles/Delete.cshtml
@model TheLittleSpoon.Models.Article

@{
    ViewData["Title"] = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Article</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Header)
        </dt>
        <dd>
            @Html.DisplayFor(model => model.Header)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="ArticleId" />
        <input type="submit" value="Delete" class="btn btn-default" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

TheLittleSpoon/Views/Articles/Details.cshtml
@using Microsoft.AspNetCore.Identity
@using TheLittleSpoon.Models

@inject SignInManager<ApplicationUser> SignInManager
@inject UserManager<ApplicationUser> UserManager


@model TheLittleSpoon.Models.Article

@{
    ViewData["Title"] = Model.Header;
}

<!-------------------------------HEADER--------------------------------->
<div class="card flex-md-row mb-4 box-shadow h-md-250 text-light bg-dark shadow">
    <div class="card-body d-flex flex-column align-items-start">
        <strong class="d-inline-block mb-2 text-primary">
            <partial name="_CategoryBadge" model="@Model.Category" />
        </strong>
        <h1 class="mb-0">@Model.Header</h1>
        <small>@Html.DisplayFor(model => model.DateCreated)</small>
        <small>@Html.DisplayFor(model => model.Location)</small>
        <br />
        <br />

        <div class="btn-group" role="group" aria-label="...">
            <div style="margin-right:5px">
                <a href="https://twitter.com/share?ref_src=twsrc%5Etfw" class="twitter-share-button btn btn-sm" data-size="large" data-show-screen-name="false" data-show-count="false">Tweet</a>
                <script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script>
            </div>
            @if (SignInManager.IsSignedIn(User))
            {
                <a asp-action="Edit" asp-route-id="@Model.ArticleId" class="btn btn-sm btn-outline-secondary">Edit</a>
            }

            <a href="/" class="btn btn-sm btn-outline-secondary">Home</a>
        </div>

    </div>
    <a asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId" style="background-color:black">
        <img class="card-img-right flex-auto d-none d-md-block" style="width: 400px;" src="@Model.HomeImageUrl" data-holder-rendered="true" />
    </a>
</div>

<div class="row">
    <div class="col-md-8">
        <!-------------------------------CONTENT--------------------------------->
        <section>
            <div class="border-bottom p-3">
                <h4>@Model.Summary</h4>
            </div>
        </section>
        </br>
        <section>
            <div id="ArticleContent" class="border-bottom">
                @Model.Content
            </div>
        </section>
        <!-------------------------------COMMENTS--------------------------------->
        <section>
            <div class="col-12">
                <h3>Comments</h3>
                <div class="border-bottom mb-2">
                    <form id="newCommentForm">
                        <div class="form-group form-group-sm">
                            <input type="text" name="Author" class="form-control" placeholder="Who are you?" />
                        </div>
                        <div class="form-group form-group-sm">
                            <textarea name="Content" class="form-control" rows="2" placeholder="And what do you think about this?"></textarea>
                        </div>
                        <div class="form-group form-group-sm">
                            <input type="hidden" name="ArticleId" class="form-control" value="@Model.ArticleId" />
                        </div>
                        <div class="form-group form-group-sm">
                            <button type="button" class="btn btn-success btn-sm mr-2" data-toggle="modal" data-target="#commentModal">Post it!</button>
                        </div>
                    </form>
                </div>
                <div class="col-md-12">
                    <small id="commentsCountLabel">
                        Loading comments...
                    </small>
                    <div class="list-group" id="commentsList">
                    </div>
                </div>
                <div id="result">
                </div>
            </div>
        </section>
    </div>
    <div class="col-lg-4">
        <aside>
            <!-------------------------------SIDEBAR--------------------------------->
            <div class="bs-example" data-example-id="default-media">

                @if (Model.IsShowMap)
                {
                    <div class="pb-3 border-bottom">
                        <h3>Location:  <span class="badge badge-secondary">@Model.Location</span></h3>
                        <div class="media">
                            <div class=" media-left">
                                <div id="articleMap" class="img-thumbnail" style="width: 350px; height: 300px;"></div>
                            </div>
                        </div>
                    </div>
                }

                <div class="mt-2">
                    <h3>Related...</h3>
                    <div class="related-articles-list" id="relatedArticlesList">
                    </div>
                </div>
            </div>
        </aside>
    </div>
</div>

<!-------------------------------COMMENTS--------------------------------->
<div class="modal" id="commentModal" tabindex="-1" role="dialog" aria-labelledby="commentModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">

            <div class="modal-header">
                <h5 class="modal-title" id="commentModalLabel">Are you sure?</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">X</span>
                </button>
            </div>
            <div class="modal-body">
                Are you sure you want to post this comment?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary" data-dismiss="modal" onclick="post_comment()">Post comment!</button>
            </div>

        </div>
    </div>
</div>

<div class="modal fade" id="errorCommentModal" tabindex="-1" role="dialog" aria-labelledby="errorCommentModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="errorCommentModalLabel">Error</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">X</span>
                </button>
            </div>
            <div class="modal-body">
                Content or author can't be empty!
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            </div>
        </div>
    </div>
</div>


@section Scripts
    {
    <!-------------------------------TEMPLATES--------------------------------->
    <script id="commentTemplate" type="text/x-jQuery-tmpl">
        <div class="media mb-1 border-bottom">
            <div class="media-left">
                <table class="comment-number-container mr-2">
                    <tbody>
                    <td class="align-middle text-center">#${sequence}</td>
                    </tbody>
                </table>
            </div>
            <div class="media-body">
                <small style="font-family:'myFont'">${author}</small>
                <p>${content}</p>
            </div>
            @if (SignInManager.IsSignedIn(User))
            {
                <button class="btn btn-danger" onclick="_delete_comment(${commentId})">X</button>
            }

        </div>
    </script>

    <script id="relatedArticleTemplate" type="text/x-jQuery-tmpl">
        <div class="card">
            <a asp-controller="Articles" asp-action="Details" asp-route-id="@Model.ArticleId">
                <img class="card-img-top"
                     style="height: 180px; width: 100%; display: block;"
                     src="${homeImageUrl}"
                     data-holder-rendered="true">
            </a>
            <div class="card-body">
                <h5 class="card-title">${header}</h5>
                <a class="btn btn-sm btn-outline-secondary" asp-controller="Articles" asp-action="MoveRelated"
                   href="/Articles/MoveRelated/?prevId=@Model.ArticleId&newId=${articleId}">Read more...</a>
            </div>
        </div>
    </script>

    <!-------------------------------SCRIPTS--------------------------------->
    <script async type="text/javascript">
        $(document).ready(function () {
            $("#ArticleContent").html(markdown_to_html("@Model.Content"));

            load_markdown_tweeter()

            $(function () {
                $('[data-toggle="tooltip"]').tooltip();
            });

            update_related_articles()
            update_comments()
        })

        var update_related_articles = function () {
            var url = "/Articles/GetRelatedArticles/" + @Model.ArticleId;
            $.getJSON(url, function (relatedArticles) {
                relatedArticles.forEach(relatedArticle => {
                    $("#relatedArticleTemplate").tmpl(relatedArticle).appendTo("#relatedArticlesList");
                })
            })
        }

        var post_comment = function () {
            var data = $("#newCommentForm").serializeArray()

            if (data[0].value == "" || data[1].value == "") {
                $('#errorCommentModal').modal('show');
            }

            new_comment(data[0].value, data[1].value, data[2].value).then(function () {
                update_comments()
            });

            console.log(data)
        }

        var _delete_comment = function (id) {
            delete_comment(id).then(function () {
                update_comments();
            })
        }

        var update_comments = function () {
            get_comments(@Model.ArticleId).then(function (comments) {
                $("#commentsList").html("");
                comments.forEach(comment => {
                    $("#commentTemplate").tmpl(comment).appendTo("#commentsList");
                    console.log(comment)
                })
                $("#commentsCountLabel").html(comments.length + " Comments")
            })
        }

    </script>

    @if (Model.IsShowMap)
    {
        <script type="text/javascript">
            var map = null;

            function LoadMap() {
                map = new Microsoft.Maps.Map('#articleMap', {
                    credentials: "AglcOvofpKm1X-WOXDY3_Cr0bxdAbKzUid-4bp7Em3BxbNPK_kT-X8iWI4B1RF0H",
                    showMapTypeSelector: false,
                    showZoomButtons: false,
                    showLocateMeButton: false
                });

                Microsoft.Maps.loadModule('Microsoft.Maps.Search', function () {
                    var searchManager = new Microsoft.Maps.Search.SearchManager(map);
                    var requestOptions = {
                        bounds: map.getBounds(),
                        where: "@Model.Location",
                        callback: function (answer, userData) {
                            map.setView({ bounds: answer.results[0].bestView });
                            map.entities.push(new Microsoft.Maps.Pushpin(answer.results[0].location))
                        }
                    };
                    searchManager.geocode(requestOptions);
                });
            }

        </script>
        <script type="text/javascript" src="https://www.bing.com/api/maps/mapcontrol?callback=LoadMap" async defer></script>
    }
}

TheLittleSpoon/Views/Articles/Index.cshtml
@model IEnumerable<TheLittleSpoon.Models.Article>

@{
    ViewData["Title"] = "Browse";
    ViewData["Tab"] = "Browse";
}
<div class="row">
    <h2>Browse all articles</h2>
    <br />
</div>
    <div class="row">
        <div class="col-9">         
            <table class="table">
                <thead>
                    <tr>
                        <th>
                            @Html.DisplayNameFor(model => model.Header)
                        </th>
                        <th>
                            @Html.DisplayNameFor(model => model.ArticleId)
                        </th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var item in Model)
                    {
                        <tr>
                            <td>
                                @Html.DisplayFor(modelItem => item.Header)
                            </td>
                            <td>
                                @Html.DisplayFor(modelItem => item.ArticleId)
                            </td>
                            <td>
                                <a class="btn alert-warning" asp-action="Edit" asp-route-id="@item.ArticleId">Edit</a>
                                <a class="btn alert-info" asp-action="Details" asp-route-id="@item.ArticleId">Details</a>
                                <a class="btn alert-danger" asp-action="Delete" asp-route-id="@item.ArticleId">Delete</a>
                            </td>
                        </tr>
                    }
                </tbody>
            </table>
        </div>
        <div class="col-3">
            <a class="btn btn-success" asp-action="Create">Create New</a>
            <br />
            <br />
            <video controls="controls" autoplay="autoplay" style="Width:255px;Height:170px">
                <source src="~/images/TheLittleSpoon%20CreateNew.mp4" type="video/mp4" />
            </video>
        </div>

    </div>